package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.ConfRestricaoTramoDAO;
import com.rjconsultores.ventaboletos.entidad.ConfRestricaoTramo;
import com.rjconsultores.ventaboletos.service.ConfRestricaoTramoService;
import com.rjconsultores.ventaboletos.service.LogAuditoriaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("confRestricaoTramoService")
public class ConfRestricaoTramoServiceImpl implements ConfRestricaoTramoService {
	
	@Autowired
	private ConfRestricaoTramoDAO confRestricaoTramoDAO;
    @Autowired
    private LogAuditoriaService logAuditoriaService;

	@Override
	public List<ConfRestricaoTramo> obtenerTodos() {
		return confRestricaoTramoDAO.obtenerTodos();
	}

	@Override
	public ConfRestricaoTramo obtenerID(Long id) {
		return confRestricaoTramoDAO.obtenerID(id);
	}
	@Transactional
	@Override
	public ConfRestricaoTramo suscribir(ConfRestricaoTramo entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return confRestricaoTramoDAO.suscribir(entidad);
	}
	@Transactional
	@Override
	public ConfRestricaoTramo actualizacion(ConfRestricaoTramo entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return confRestricaoTramoDAO.actualizacion(entidad);
	}

	@Transactional
	@Override
	public void borrar(ConfRestricaoTramo entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.FALSE);

		confRestricaoTramoDAO.actualizacion(entidad);
//		logAuditoriaService.auditarExclusao(entidad, null);
		
	}
	
	@Override
	@Transactional
	public void actualizacionAuditagem(List<ConfRestricaoTramo> lsConfRestricaoTramo) {
		for (ConfRestricaoTramo cc : lsConfRestricaoTramo) {
			if(Boolean.TRUE.equals(cc.getActivo())) {
				continue;
			}
			confRestricaoTramoDAO.actualizacion(cc);
		}
		
	}
}
